commit d3f2f039b29027ea89c7d29279d122d675d29780
Author: freddy77 <freddy77>
Date:   Mon Jul 7 11:27:11 2008 +0000

    start sqlwchar support

diff --git a/ChangeLog b/ChangeLog
index d6051be..030561a 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,7 @@
+Mon Jul 07 13:23:52 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* include/tdsodbc.h src/odbc/Makefile.am src/odbc/sql2tds.c:
+	- start wchar support
+
 Mon Jul 07 13:09:20 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* src/ctlib/unittests/common.c: make portable to win32
 	* src/odbc/prepare_query.c: add small comment
@@ -383,4 +387,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog  truncated because of release
 	* ChangeLog-0.82 added because of release
 	
-$Id: ChangeLog,v 1.2541 2008/07/07 11:09:40 freddy77 Exp $
+$Id: ChangeLog,v 1.2542 2008/07/07 11:27:11 freddy77 Exp $
diff --git a/include/tdsodbc.h b/include/tdsodbc.h
index 5efd600..e52c366 100644
--- a/include/tdsodbc.h
+++ b/include/tdsodbc.h
@@ -66,7 +66,7 @@ extern "C"
 #endif
 #endif
 
-/* $Id: tdsodbc.h,v 1.105 2008/03/13 13:23:31 freddy77 Exp $ */
+/* $Id: tdsodbc.h,v 1.106 2008/07/07 11:27:12 freddy77 Exp $ */
 
 #if defined(__GNUC__) && __GNUC__ >= 4
 #pragma GCC visibility push(hidden)
@@ -521,6 +521,15 @@ const char *parse_const_param(const char * s, TDS_SERVER_TYPE *type);
  */
 SQLRETURN sql2tds(TDS_STMT * stmt, const struct _drecord *drec_ixd, const struct _drecord *drec_axd, TDSCOLUMN *curcol, int compute_row, const TDS_DESC* axd, unsigned int n_row);
 
+/*
+ * sqlwchar.c
+ */
+#if SIZEOF_SQLWCHAR != SIZEOF_WCHAR_T
+size_t sqlwcslen(const SQLWCHAR * s);
+#else
+#define sqlwcslen wcslen
+#endif
+
 #if defined(__GNUC__) && __GNUC__ >= 4
 #pragma GCC visibility pop
 #endif
diff --git a/src/odbc/Makefile.am b/src/odbc/Makefile.am
index f8799da..56cecf5 100644
--- a/src/odbc/Makefile.am
+++ b/src/odbc/Makefile.am
@@ -1,4 +1,4 @@
-# $Id: Makefile.am,v 1.45 2007/12/03 18:55:09 freddy77 Exp $
+# $Id: Makefile.am,v 1.46 2008/07/07 11:27:12 freddy77 Exp $
 SUBDIRS		= unittests
 AM_CPPFLAGS	=	-I$(top_srcdir)/include $(ODBC_INC)
 
@@ -11,7 +11,7 @@ MINGW_SOURCES	=
 endif
 libtdsodbc_la_SOURCES=	odbc.c connectparams.c convert_tds2sql.c \
 	descriptor.c prepare_query.c odbc_util.c \
-	native.c sql2tds.c error.c odbc_checks.c $(MINGW_SOURCES)
+	native.c sql2tds.c error.c odbc_checks.c sqlwchar.c $(MINGW_SOURCES)
 if MINGW32
 libtdsodbc_la_LIBADD=	../../win32/setup.res ../tds/libtds.la ../replacements/libreplacements.la $(ODBCINSTLIB) \
 	$(NETWORK_LIBS) $(LIBICONV) $(FREETDS_LIBGCC)
diff --git a/src/odbc/sql2tds.c b/src/odbc/sql2tds.c
index 507a996..449850d 100644
--- a/src/odbc/sql2tds.c
+++ b/src/odbc/sql2tds.c
@@ -52,7 +52,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: sql2tds.c,v 1.65 2008/01/07 21:00:09 freddy77 Exp $");
+TDS_RCSID(var, "$Id: sql2tds.c,v 1.66 2008/07/07 11:27:12 freddy77 Exp $");
 
 static TDS_INT
 convert_datetime2server(int bindtype, const void *src, TDS_DATETIME * dt)
@@ -241,7 +241,10 @@ sql2tds(TDS_STMT * stmt, const struct _drecord *drec_ipd, const struct _drecord
 			odbc_errs_add(&stmt->errs, "HY090", NULL);
 			return SQL_ERROR;
 		}
-		len = strlen(src);
+		if (sql_src_type == SQL_C_WCHAR)
+			len = sqlwcslen(src);
+		else
+			len = strlen(src);
 		break;
 	case SQL_DEFAULT_PARAM:
 	case SQL_DATA_AT_EXEC:
@@ -254,6 +257,7 @@ sql2tds(TDS_STMT * stmt, const struct _drecord *drec_ipd, const struct _drecord
 			/* test for SQL_C_CHAR/SQL_C_BINARY */
 			switch (sql_src_type) {
 			case SQL_C_CHAR:
+			case SQL_C_WCHAR:
 			case SQL_C_BINARY:
 				break;
 			default:
@@ -265,6 +269,7 @@ sql2tds(TDS_STMT * stmt, const struct _drecord *drec_ipd, const struct _drecord
 			/* dynamic length allowed only for BLOB fields */
 			switch (drec_ipd->sql_desc_concise_type) {
 			case SQL_LONGVARCHAR:
+			case SQL_WLONGVARCHAR:
 			case SQL_LONGVARBINARY:
 				break;
 			default:

